## optee-test 4.2.0

=== ta/Makefile ===
# Normally this makefile shouldn't be called directly and we expect the output
# path to be on a certain location to fit together with the other OP-TEE
# gits and helper scripts.

include ../scripts/common.mk
out-dir := $(call strip-trailing-slashes-and-dots,$(O))
ifeq ($(out-dir),)
$(error invalid output directory (O=$(O)))
endif

include $(TA_DEV_KIT_DIR)/mk/conf.mk

# Prevent use of LDFLAGS from the environment. For example, yocto exports
# LDFLAGS that are suitable for the client applications, not for TAs
LDFLAGS=

TA_DIRS := create_fail_test \
	   crypt \
	   os_test_lib \
	   os_test_lib_dl \
	   os_test \
	   rpc_test \
	   sims \
	   miss \
	   sims_keepalive \
	   storage \
	   storage2 \
	   concurrent \
	   concurrent_large \
	   storage_benchmark \
	   crypto_perf \
	   socket \
	   supp_plugin \
	   large \
	   subkey1 \
	   subkey2

ifeq ($(CFG_SECURE_DATA_PATH),y)
TA_DIRS += sdp_basic
endif

ifeq ($(CFG_TA_BTI),y)
TA_DIRS += bti_test
endif

.PHONY: all
all: ta

.PHONY: ta
ta:
	$(q)$(foreach dir,$(TA_DIRS), $(MAKE) -C $(dir) O=$(out-dir)/ta/$(dir) &&) true

# remove build directories including ta/<ta-name>/ directories.
# Note: $(out-dir) may be a relative path.
RMDIR := rmdir --ignore-fail-on-non-empty
define rm-build-subdir
echo `[ -d $1 ] && { cd $1; $(RMDIR) $(out-dir)/ta $(out-dir) 2> /dev/null; true; }` > /dev/null
endef

.PHONY: clean
clean:
	$(q)$(foreach dir,$(TA_DIRS), [ ! -d $(dir) ] || $(MAKE) -C $(dir) O=$(out-dir)/ta/$(dir) $@ &&) true
	$(q)$(foreach dir,$(TA_DIRS), $(call rm-build-subdir,$(dir));)

=== host/xtest/Makefile ===
# Normally this makefile shouldn't be called directly and we expect the output
# path to be on a certain location to fit together with the other OP-TEE
# gits and helper scripts.

include ../../scripts/common.mk
out-dir := $(call strip-trailing-slashes-and-dots,$(O))
ifeq ($(out-dir),)
$(error invalid output directory (O=$(O)))
endif

include $(TA_DEV_KIT_DIR)/host_include/conf.mk

# By default we expect optee_client exported folder to be on a certain relative
# path, but if the client specifies the OPTEE_CLIENT_EXPORT then that path will
# be used instead.
OPTEE_CLIENT_EXPORT ?= ../../../optee_client/out/export

CC		?= $(CROSS_COMPILE)gcc
CPP		?= $(CROSS_COMPILE)cpp
LD		?= $(CROSS_COMPILE)ld
AR		?= $(CROSS_COMPILE)ar
NM		?= $(CROSS_COMPILE)nm
OBJCOPY		?= $(CROSS_COMPILE)objcopy
OBJDUMP		?= $(CROSS_COMPILE)objdump
READELF		?= $(CROSS_COMPILE)readelf

# Macros to detect the targeted architecture (e.g., arm-linux-gnueabihf or
# aarch64-linux-gnu) and the corresponding bit size (32 or 64).
define cc-arch
$(shell $(1) -v 2>&1 | grep Target | sed 's/Target: \([^-]*\).*/\1/')
endef
define cc-bits
$(if $(filter arm, $(1)),32,$(if $(filter aarch64, $(1)),64,unknown-arch))
endef

# OpenSSL is used by:
# - GP tests series 8500
# - Mbed TLS test 8103
# - User/group login tests 1027 and 1028
WITH_OPENSSL ?= y
ifeq ($(WITH_OPENSSL),y)
CFLAGS += -DOPENSSL_FOUND=1 -DOPENSSL_API_COMPAT=10100
LDFLAGS += -lcrypto
endif #require OpenSSL

srcs := regression_1000.c

ifeq ($(CFG_GP_SOCKETS),y)
srcs += regression_2000.c \
	sock_server.c \
	rand_stream.c
endif

srcs +=	adbg/src/adbg_case.c \
	adbg/src/adbg_enum.c \
	adbg/src/adbg_expect.c \
	adbg/src/adbg_log.c \
	adbg/src/adbg_run.c \
	adbg/src/security_utils_hex.c \
	asym_perf.c \
	benchmark_1000.c \
	benchmark_2000.c \
	clear_storage.c \
	regression_4000.c \
	regression_4100.c \
	regression_5000.c \
	regression_6000.c \
	regression_8000.c \
	regression_8100.c \
	hash_perf.c \
	stats.c \
	symm_cipher_perf.c \
	xtest_helpers.c \
	xtest_main.c \
	xtest_test.c \
	xtest_uuid_helpers.c

ifeq ($(CFG_SECURE_PARTITION)-$(CFG_SPMC_TESTS),y-y)
srcs += ffa_spmc_1000.c
endif

ifeq ($(CFG_SECSTOR_TA_MGMT_PTA),y)
srcs += install_ta.c
endif

ifeq ($(CFG_SECURE_DATA_PATH),y)
srcs += sdp_basic.c
endif

ifeq ($(CFG_PKCS11_TA),y)
srcs += pkcs11_1000.c
endif

objs 	:= $(patsubst %.c,$(out-dir)/xtest/%.o, $(srcs))

ifeq ($(CFG_PKCS11_TA),y)
CFLAGS += -DCFG_PKCS11_TA
endif

ifeq ($(CFG_CRYPTO_SE05X),y)
CFLAGS += -DCFG_CRYPTO_SE05X
endif

CFLAGS += -I./
CFLAGS += -I./adbg/include
CFLAGS += -I../supp_plugin/include
CFLAGS += -I$(out-dir)/xtest

CFLAGS += -I$(OPTEE_CLIENT_EXPORT)/include
CFLAGS += -I$(TA_DEV_KIT_DIR)/host_include

CFLAGS += -I../../ta/include
CFLAGS += -I../../ta/create_fail_test/include
CFLAGS += -I../../ta/crypt/include
CFLAGS += -I../../ta/enc_fs/include
CFLAGS += -I../../ta/os_test/include
CFLAGS += -I../../ta/rpc_test/include
CFLAGS += -I../../ta/sims/include
CFLAGS += -I../../ta/miss/include
CFLAGS += -I../../ta/sims_keepalive/include
CFLAGS += -I../../ta/storage_benchmark/include
CFLAGS += -I../../ta/concurrent/include
CFLAGS += -I../../ta/concurrent_large/include
CFLAGS += -I../../ta/crypto_perf/include
CFLAGS += -I../../ta/socket/include
CFLAGS += -I../../ta/sdp_basic/include
CFLAGS += -I../../ta/tpm_log_test/include
CFLAGS += -I../../ta/large/include
CFLAGS += -I../../ta/supp_plugin/include
CFLAGS += -I../../ta/bti_test/include
CFLAGS += -I../../ta/subkey1/include
CFLAGS += -I../../ta/subkey2/include

TA_DIR ?= /lib/optee_armtz
CFLAGS += -DTA_DIR=\"$(TA_DIR)\"

# Include configuration file generated by OP-TEE OS (CFG_* macros)
CFLAGS += -include conf.h

CFLAGS += -Wall -Wcast-align -Werror \
	  -Werror-implicit-function-declaration -Wextra -Wfloat-equal \
	  -Wformat-nonliteral -Wformat-security -Wformat=2 -Winit-self \
	  -Wmissing-declarations -Wmissing-format-attribute \
	  -Wmissing-include-dirs \
	  -Wmissing-prototypes -Wnested-externs -Wpointer-arith \
	  -Wshadow -Wstrict-prototypes -Wswitch-default \
	  -Wwrite-strings -Wno-unused-parameter \
	  -Wno-declaration-after-statement \
	  -Wno-missing-field-initializers -Wno-format-zero-length

CFLAGS += -g3

LDFLAGS += -L$(OPTEE_CLIENT_EXPORT)/lib -lteec
ifeq ($(CFG_PKCS11_TA),y)
LDFLAGS += -lckteec
endif
LDFLAGS += -lpthread -lm

.PHONY: all
all: xtest

xtest: $(objs)
	@echo "  LD      $(out-dir)/xtest/$@"
	$(q)$(CC) -o $(out-dir)/xtest/$@ $+ $(LDFLAGS)

$(out-dir)/xtest/%.o: $(CURDIR)/%.c
	$(q)mkdir -p $(out-dir)/xtest/adbg/src
	@echo '  CC      $<'
	$(q)$(CC) $(CFLAGS) -c $< -o $@

RMDIR := rmdir --ignore-fail-on-non-empty
define rm-build-dirs
	$(q)for d in $1; do $(RMDIR) $(out-dir)/xtest/$$d 2> /dev/null; true; done
	$(q)$(RMDIR) $(out-dir)/xtest 2> /dev/null; true
	$(q)$(RMDIR) $(out-dir) 2> /dev/null; true
endef

ifeq ($(CFG_GCM_NIST_VECTORS),y)
GCM_NIST_VECTORS_DECRYPT = gcmDecrypt128 gcmDecrypt192 gcmDecrypt256
GCM_NIST_VECTORS_ENCRYPT = gcmEncryptExtIV128 gcmEncryptExtIV192 \
			   gcmEncryptExtIV256

cleanfiles += $(out-dir)/gcmtestvectors.zip
$(out-dir)/gcmtestvectors.zip:
	@echo '  DL      $@'
	$(q)curl https://csrc.nist.gov/csrc/media/projects/cryptographic-algorithm-validation-program/documents/mac/gcmtestvectors.zip -o $@

define create-nist-gcm-vectors
cleanfiles += $(out-dir)/xtest/$(1).h $(out-dir)/$(1).rsp

$(out-dir)/$(1).rsp: $(out-dir)/gcmtestvectors.zip
	@echo '  UNZIP   $$@'
	$(q)unzip -o $$< $$(notdir $$@) -d $$(dir $$@)
	$(q)touch $$@


$(out-dir)/xtest/$(1).h: $(out-dir)/$(1).rsp
	@echo '  GEN     $$@'
	$(q)$(PYTHON3) ../../scripts/rsp_to_gcm_test.py --inf $$< --outf $$@ --mode=$(2) \
		$(if $(filter y,$(CFG_GCM_NIST_VECTORS_LIMITED)),--limited)

$(CURDIR)/regression_4000.c: $(out-dir)/xtest/$(1).h
endef

$(foreach v, $(GCM_NIST_VECTORS_DECRYPT), $(eval $(call \
	create-nist-gcm-vectors,$v,decrypt)))
$(foreach v, $(GCM_NIST_VECTORS_ENCRYPT), $(eval $(call \
	create-nist-gcm-vectors,$v,encrypt)))
endif

define embed-file
cleanfiles += $(out-dir)/xtest/$(1).h

$(out-dir)/xtest/$(1).h: $(2)
	$(q)mkdir -p $(out-dir)/xtest/
	@echo '  GEN     $$@'
	$(q)$(PYTHON3) ../../scripts/file_to_c.py --inf $$< --out $$@ --name $(1)

$(CURDIR)/regression_8100.c: $(out-dir)/xtest/$(1).h
endef

$(eval $(call embed-file,regression_8100_ca_crt,../../cert/ca.crt))
$(eval $(call embed-file,regression_8100_mid_crt,../../cert/mid.crt))
$(eval $(call embed-file,regression_8100_my_crt,../../cert/my.crt))
$(eval $(call embed-file,regression_8100_my_csr,../../cert/my.csr))

.PHONY: clean
clean:
	@echo '  CLEAN $(out-dir)'
	$(q)rm -f $(out-dir)/xtest/xtest
	$(q)$(foreach obj,$(objs), rm -f $(obj))
	$(q)rm -f $(cleanfiles)
	$(call rm-build-dirs,adbg/src adbg)

=== debian/changelog ===
optee-test (4.2.0-1) unstable; urgency=medium

  * Initial debian packaging (Closes: #868216)

 -- Dylan Aïssi <daissi@debian.org>  Tue, 07 May 2024 11:41:43 +0200

=== debian/control ===
Source: optee-test
Section: devel
Priority: optional
Maintainer: Dylan Aïssi <daissi@debian.org>
Standards-Version: 4.7.0
Build-Depends: debhelper-compat (= 13),
               libssl-dev,
               optee-client-dev (>=4.2.0) [arm64],
               optee-os-dev (>=4.2.0) [arm64],
               python3,
               python3-cryptography
Vcs-Browser: https://salsa.debian.org/debian/optee-test
Vcs-Git: https://salsa.debian.org/debian/optee-test.git
Homepage: https://www.trustedfirmware.org/projects/op-tee
Rules-Requires-Root: no

Package: optee-test-qemu
Architecture: arm64
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: OP-TEE sanity testsuite
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the API
 describing how to communicate with a TEE. Those APIs are defined in the
 GlobalPlatform API specifications.
 .
 The package includes the TEE sanity testsuite using the ARM(R) TrustZone(R)
 technology.

## optee-test 4.3.0

=== host/xtest/CMakeLists.txt ===
project (xtest C)

include(${OPTEE_TEST_SDK}/host_include/conf.cmake)

################################################################################
# Packages
################################################################################
find_package(Threads REQUIRED)
if(NOT THREADS_FOUND)
	message(FATAL_ERROR "Threads not found")
endif()

find_package(OpenSSL)
if(OPENSSL_FOUND)
	add_compile_options(-DOPENSSL_FOUND=1 -DOPENSSL_API_COMPAT=10100)
	set (OPENSSL_PRIVATE_LINK OpenSSL::Crypto)
endif()

find_package(Python REQUIRED)

include(GNUInstallDirs)

macro(EMBED_8100FILE prefix infile)
	add_custom_command(
		OUTPUT  regression_8100_${prefix}.h
		COMMAND ${Python_EXECUTABLE} ${OPTEE_TEST_ROOT_DIR}/scripts/file_to_c.py --inf ${infile}
	--out ${CMAKE_CURRENT_BINARY_DIR}/regression_8100_${prefix}.h
	--name regression_8100_${prefix}
		DEPENDS ${OPTEE_TEST_ROOT_DIR}/scripts/file_to_c.py ${infile}
	)

	set_property(SOURCE regression_8100.c APPEND PROPERTY OBJECT_DEPENDS
		     ${CMAKE_CURRENT_BINARY_DIR}/regression_8100_${prefix}.h)
endmacro(EMBED_8100FILE)

EMBED_8100FILE(ca_crt ${OPTEE_TEST_ROOT_DIR}/cert/ca.crt)
EMBED_8100FILE(mid_crt ${OPTEE_TEST_ROOT_DIR}/cert/mid.crt)
EMBED_8100FILE(my_crt ${OPTEE_TEST_ROOT_DIR}/cert/my.crt)
EMBED_8100FILE(my_csr ${OPTEE_TEST_ROOT_DIR}/cert/my.csr)

set (SRC
	adbg/src/adbg_case.c
	adbg/src/adbg_enum.c
	adbg/src/adbg_expect.c
	adbg/src/adbg_log.c
	adbg/src/adbg_run.c
	adbg/src/security_utils_hex.c
	asym_perf.c
	benchmark_1000.c
	benchmark_2000.c
	clear_storage.c
	regression_1000.c
	regression_4000.c
	regression_4100.c
	regression_5000.c
	regression_6000.c
	regression_8000.c
	regression_8100.c
	hash_perf.c
	stats.c
	symm_cipher_perf.c
	xtest_helpers.c
	xtest_main.c
	xtest_test.c
	xtest_uuid_helpers.c
)
if(CFG_SECURE_PARTITION AND CFG_SPMC_TESTS)
	list (APPEND SRC ffa_spmc_1000.c)
endif()

if (WITH_GP_TESTS)
	add_compile_options(-DWITH_GP_TESTS=1)

	macro(__GEN_GP_FILE outfile xmldir name basedir)
		add_custom_command(
			OUTPUT	${outfile}
			COMMAND	xalan -in ${basedir}/${name}.xml
				      -xsl gp/${name}.xsl -out ${outfile}
			DEPENDS ${basedir}/${name}.xml gp/${name}.xsl
		)
	endmacro(__GEN_GP_FILE)
	macro(GEN_GP_FILE outfile xmldir name)
		__GEN_GP_FILE(${outfile} ${xmldir} ${name}
			      gp-suite/packages/${xmldir})
		list (APPEND SRC ${outfile})
	endmacro(GEN_GP_FILE)

	GEN_GP_FILE(gp_10000.c ClientAPI/xmlstable TEE)
	GEN_GP_FILE(gp_20000.c TrustedCoreFw/xmlstable TEE_Internal_API)
	GEN_GP_FILE(gp_30000.c DataStorage/xmlstable TEE_DataStorage_API)
	GEN_GP_FILE(gp_40000.c Time_Arithmetical/xmlstable TEE_TimeArithm_API)
	GEN_GP_FILE(gp_50000.c Crypto/xmlstable TEE_Crypto_API)
	set (GP_INCLUDES PRIVATE gp/include)
endif()

if (CFG_GP_SOCKETS)
	list (APPEND SRC
		regression_2000.c
		sock_server.c
		rand_stream.c
	)
endif()

if (CFG_SECSTOR_TA_MGMT_PTA)
	list (APPEND SRC install_ta.c)
endif()

if (CFG_SECURE_DATA_PATH)
	list (APPEND SRC sdp_basic.c)
endif()

if (CFG_PKCS11_TA)
	add_compile_options(-DCFG_PKCS11_TA)
	list (APPEND SRC pkcs11_1000.c)
endif()

if (CFG_CRYPTO_SE05X)
	add_compile_options(-DCFG_CRYPTO_SE05X)
endif()

################################################################################
# Built binary
################################################################################
add_executable (${PROJECT_NAME} ${SRC})

target_compile_options (${PROJECT_NAME} PRIVATE -include conf.h)

target_include_directories(${PROJECT_NAME}
	PRIVATE .
	PRIVATE ../supp_plugin/include
	PRIVATE adbg/include
	PRIVATE ${OPTEE_TEST_SDK}/host_include
	PRIVATE ${CMAKE_CURRENT_BINARY_DIR}
	${GP_INCLUDES}
)

target_link_libraries (${PROJECT_NAME}
	PRIVATE ${CMAKE_THREAD_LIBS_INIT}
	PRIVATE xtest-ta-headers
	PRIVATE teec
	PRIVATE m
	PRIVATE ${OPENSSL_PRIVATE_LINK}
	PRIVATE ckteec
)

################################################################################
# Install targets
################################################################################
install (TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})

=== host/xtest/Makefile ===
--- 
+++ 
@@ -40,6 +40,10 @@
 WITH_OPENSSL ?= y
 ifeq ($(WITH_OPENSSL),y)
 CFLAGS += -DOPENSSL_FOUND=1 -DOPENSSL_API_COMPAT=10100
+ifneq ($(OPENSSL_INSTALL_PATH),)
+CFLAGS += -I$(OPENSSL_INSTALL_PATH)/include
+LDFLAGS += -L$(OPENSSL_INSTALL_PATH)/lib
+endif
 LDFLAGS += -lcrypto
 endif #require OpenSSL

=== debian/changelog ===
optee-test (4.3.0-1) unstable; urgency=medium

  * New upstream version 4.3.0
  * Bump version of optee-*-dev to >= 4.3.0

 -- Dylan Aïssi <daissi@debian.org>  Thu, 25 Jul 2024 11:20:46 +0200

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Standards-Version: 4.7.0
 Build-Depends: debhelper-compat (= 13),
                libssl-dev,
-               optee-client-dev (>=4.2.0) [arm64],
-               optee-os-dev (>=4.2.0) [arm64],
+               optee-client-dev (>=4.3.0) [arm64],
+               optee-os-dev (>=4.3.0) [arm64],
                python3,
                python3-cryptography
 Vcs-Browser: https://salsa.debian.org/debian/optee-test

=== debian/rules ===
#!/usr/bin/make -f

export TA_DEV_KIT_DIR = /usr/lib/optee-os-dev/vexpress-qemu_armv8a/
export OPTEE_CLIENT_EXPORT = /usr
export V = 1
export CROSS_COMPILE = $(DEB_HOST_GNU_TYPE)-

# Use the system openssl instead of the embedded one
export OPTEE_OPENSSL_EXPORT=/usr/include/

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND = -Wno-format-truncation

%:
	dh $@

## optee-test 4.5.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.4)
project (optee_test C)

# Default cross compile settings
set (CMAKE_TOOLCHAIN_FILE CMakeToolchain.txt)

set (OPTEE_TEST_ROOT_DIR ${CMAKE_CURRENT_SOURCE_DIR})
################################################################################
# Compiler flags:
#   We want to use the same flags in the entire optee_client git
################################################################################
add_compile_options (
	-Wall -Wbad-function-cast -Wcast-align
	-Werror-implicit-function-declaration -Wextra
	-Wfloat-equal -Wformat-nonliteral -Wformat-security
	-Wformat=2 -Winit-self -Wmissing-declarations
	-Wmissing-format-attribute -Wmissing-include-dirs
	-Wmissing-prototypes -Wnested-externs
	-Wpointer-arith -Wshadow -Wstrict-prototypes
	-Wswitch-default -Wunsafe-loop-optimizations
	-Wwrite-strings -Werror -fPIC
 	-Wno-missing-field-initializers
	-Wno-unused-parameter
)

find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
	set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
	set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif(CCACHE_FOUND)

add_subdirectory (ta)
add_subdirectory (host/xtest)
add_subdirectory (host/supp_plugin)

=== host/supp_plugin/CMakeLists.txt ===
project (f07bfc66-958c-4a15-99c0-260e4e7375dd.plugin C)

set (CFG_TEE_PLUGIN_LOAD_PATH "/usr/lib/tee-supplicant/plugins/")
set (CMAKE_SHARED_LIBRARY_PREFIX "")

add_library(${PROJECT_NAME} SHARED test_supp_plugin.c)
target_include_directories(${PROJECT_NAME} PRIVATE ./include)

target_link_libraries (${PROJECT_NAME} PRIVATE teec)

install (TARGETS ${PROJECT_NAME} DESTINATION ${CFG_TEE_PLUGIN_LOAD_PATH})

=== host/xtest/Makefile ===
--- 
+++ 
@@ -72,6 +72,7 @@
 	regression_8000.c \
 	regression_8100.c \
 	hash_perf.c \
+	install_ta.c \
 	stats.c \
 	symm_cipher_perf.c \
 	xtest_helpers.c \
@@ -83,10 +84,6 @@
 srcs += ffa_spmc_1000.c
 endif
 
-ifeq ($(CFG_SECSTOR_TA_MGMT_PTA),y)
-srcs += install_ta.c
-endif
-
 ifeq ($(CFG_SECURE_DATA_PATH),y)
 srcs += sdp_basic.c
 endif
@@ -107,6 +104,7 @@
 
 CFLAGS += -I./
 CFLAGS += -I./adbg/include
+CFLAGS += -I./include/uapi
 CFLAGS += -I../supp_plugin/include
 CFLAGS += -I$(out-dir)/xtest

=== ta/os_test_lib/Makefile ===
include $(TA_DEV_KIT_DIR)/mk/conf.mk

SHLIBNAME = libos_test
SHLIBUUID = ffd2bded-ab7d-4988-95ee-e4962fff7154
include ../ta_common.mk

=== ta/sims_keepalive/Makefile ===
BINARY = a4c04d50-f180-11e8-8eb2-f2801f1b9fd1
include ../ta_common.mk

=== debian/changelog ===
optee-test (4.5.0-1) unstable; urgency=medium

  * New upstream version 4.5.0
  * Bump version of optee-*-dev to >= 4.5.0
  * Export CRYPTOGRAPHY_OPENSSL_NO_LEGACY=1

 -- Dylan Aïssi <daissi@debian.org>  Thu, 23 Jan 2025 09:41:37 +0100

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Standards-Version: 4.7.0
 Build-Depends: debhelper-compat (= 13),
                libssl-dev,
-               optee-client-dev (>=4.3.0) [arm64],
-               optee-os-dev (>=4.3.0) [arm64],
+               optee-client-dev (>=4.5.0) [arm64],
+               optee-os-dev (>=4.5.0) [arm64],
                python3,
                python3-cryptography
 Vcs-Browser: https://salsa.debian.org/debian/optee-test

=== debian/rules ===
--- 
+++ 
@@ -12,5 +12,7 @@
 
 export DEB_CFLAGS_MAINT_APPEND = -Wno-format-truncation
 
+export CRYPTOGRAPHY_OPENSSL_NO_LEGACY=1
+
 %:
 	dh $@

## optee-test 4.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,10 @@
-cmake_minimum_required (VERSION 3.4)
+cmake_minimum_required (VERSION 3.5)
 project (optee_test C)
 
 # Default cross compile settings
 set (CMAKE_TOOLCHAIN_FILE CMakeToolchain.txt)
+
+option(CFG_WERROR "Build with -Werror" FALSE)
 
 set (OPTEE_TEST_ROOT_DIR ${CMAKE_CURRENT_SOURCE_DIR})
 ################################################################################
@@ -18,10 +20,13 @@
 	-Wmissing-prototypes -Wnested-externs
 	-Wpointer-arith -Wshadow -Wstrict-prototypes
 	-Wswitch-default -Wunsafe-loop-optimizations
-	-Wwrite-strings -Werror -fPIC
+	-Wwrite-strings -fPIC
  	-Wno-missing-field-initializers
-	-Wno-unused-parameter
+	-Wno-unused-parameter -Wno-alloc-size
 )
+if(CFG_WERROR)
+    add_compile_options(-Werror)
+endif(CFG_WERROR)
 
 find_program(CCACHE_FOUND ccache)
 if(CCACHE_FOUND)

=== Makefile ===
ifeq ($O,)
out-dir := $(CURDIR)/out
else
include scripts/common.mk
out-dir := $(call strip-trailing-slashes-and-dots,$(O))
ifeq ($(out-dir),)
$(error invalid output directory (O=$(O)))
endif
endif

bindir ?= /bin
libdir ?= /lib

-include $(TA_DEV_KIT_DIR)/host_include/conf.mk
-include $(OPTEE_CLIENT_EXPORT)/include/optee_client_config.mk

ifneq ($V,1)
	q := @
	echo := @echo
else
	q :=
	echo := @:
endif
# export 'q', used by sub-makefiles.
export q

# If _HOST or _TA specific compilers are not specified, then use CROSS_COMPILE
CROSS_COMPILE_HOST ?= $(CROSS_COMPILE)
CROSS_COMPILE_TA ?= $(CROSS_COMPILE)

.PHONY: all
ifneq ($(wildcard $(TA_DEV_KIT_DIR)/host_include/conf.mk),)
all: xtest ta test_plugin
else
all:
	$(q)echo "TA_DEV_KIT_DIR is not correctly defined" && false
endif

.PHONY: xtest
xtest:
	$(q)$(MAKE) -C host/xtest CROSS_COMPILE="$(CROSS_COMPILE_HOST)" \
			     --no-builtin-variables \
			     O=$(out-dir) \
			     $@

.PHONY: ta
ta:
	$(q)$(MAKE) -C ta CROSS_COMPILE="$(CROSS_COMPILE_TA)" \
			  O=$(out-dir) \
			  $@

.PHONY: test_plugin
test_plugin:
	$(q)$(MAKE) -C host/supp_plugin CROSS_COMPILE="$(CROSS_COMPILE_HOST)" \
			     --no-builtin-variables \
			     O=$(out-dir)

.PHONY: clean
ifneq ($(wildcard $(TA_DEV_KIT_DIR)/host_include/conf.mk),)
clean:
	$(q)$(MAKE) -C host/xtest O=$(out-dir) $@
	$(q)$(MAKE) -C ta O=$(out-dir) $@
	$(q)$(MAKE) -C host/supp_plugin O=$(out-dir) $@
else
clean:
	$(q)echo "TA_DEV_KIT_DIR is not correctly defined"
	$(q)echo "You can remove manually $(out-dir)"
endif

.PHONY: checkpatch checkpatch-staging checkpatch-working
checkpatch: checkpatch-staging checkpatch-working

checkpatch-working:
	@./scripts/checkpatch.sh

checkpatch-staging:
	@./scripts/checkpatch.sh --cached

install:
	$(echo) '  INSTALL ${DESTDIR}${libdir}/optee_armtz'
	$(q)mkdir -p ${DESTDIR}${libdir}/optee_armtz
	$(q)find $(out-dir) -name \*.ta -exec cp {} ${DESTDIR}${libdir}/optee_armtz \;
	$(echo) '  INSTALL ${DESTDIR}${bindir}'
	$(q)mkdir -p ${DESTDIR}${bindir}
	$(q)cp $(out-dir)/xtest/xtest ${DESTDIR}${bindir}
	$(echo) '  INSTALL ${DESTDIR}/$(CFG_TEE_PLUGIN_LOAD_PATH)'
	$(q)mkdir -p ${DESTDIR}/$(CFG_TEE_PLUGIN_LOAD_PATH)
	$(q)cp $(out-dir)/supp_plugin/*.plugin ${DESTDIR}/$(CFG_TEE_PLUGIN_LOAD_PATH)

.PHONY: cscope
cscope:
	$(echo) '  CSCOPE  .'
	${q}rm -f cscope.*
	${q}find $(PWD) -name "*.[ch]" -o -name "*.cpp" | grep -v /package/ > cscope.files
	${q}cscope -b -q -k

=== ta/CMakeLists.txt ===
project (xtest-ta-headers C)

add_library(${PROJECT_NAME} INTERFACE)

target_include_directories(${PROJECT_NAME}
	INTERFACE include
	INTERFACE concurrent/include
	INTERFACE concurrent_large/include
	INTERFACE create_fail_test/include
	INTERFACE crypt/include
	INTERFACE crypto_perf/include
	INTERFACE enc_fs/include
	INTERFACE os_test/include
	INTERFACE rpc_test/include
	INTERFACE sdp_basic/include
	INTERFACE sims/include
	INTERFACE miss/include
	INTERFACE sims_keepalive/include
	INTERFACE socket/include
	INTERFACE storage_benchmark/include
	INTERFACE tpm_log_test/include
	INTERFACE bti_test/include
	INTERFACE supp_plugin/include
	INTERFACE large/include
	INTERFACE subkey1/include
	INTERFACE subkey2/include
)

=== host/supp_plugin/Makefile ===
PLUGIN_UUID = f07bfc66-958c-4a15-99c0-260e4e7375dd

PLUGIN			= $(PLUGIN_UUID).plugin
PLUGIN_SRS		= $(wildcard ./*.c)
PLUGIN_OBJ		= $(patsubst %.c, $(O)/supp_plugin/%.o, $(PLUGIN_SRS))
PLUGIN_INCLUDES_DIR	= $(CURDIR)/include $(OPTEE_CLIENT_EXPORT)/include

PLUGIN_INCLUDES		= $(addprefix -I, $(PLUGIN_INCLUDES_DIR))
PLUGIN_CCFLAGS		= $(CFLAGS) -Wall -fPIC
PLUGIN_LDFLAGS		= $(LDFLAGS) -shared

CC			?= $(CROSS_COMPILE)gcc

$(O)/supp_plugin/$(PLUGIN): $(PLUGIN_OBJ)
	$(q)$(CC) $(PLUGIN_LDFLAGS) $(PLUGIN_OBJ) -o $@

$(O)/supp_plugin/%.o: $(CURDIR)/%.c
	$(q)mkdir -p $(O)/supp_plugin
	@echo '  CC      $<'
	$(q)$(CC) $(PLUGIN_INCLUDES) $(PLUGIN_CCFLAGS) -c $< -o $@

.PHONY: clean
clean:
	$(q)$(RM) -rf $(O)/supp_plugin/

=== host/xtest/CMakeLists.txt ===
--- 
+++ 
@@ -57,6 +57,7 @@
 	regression_8000.c
 	regression_8100.c
 	hash_perf.c
+	install_ta.c
 	stats.c
 	symm_cipher_perf.c
 	xtest_helpers.c
@@ -74,8 +75,8 @@
 	macro(__GEN_GP_FILE outfile xmldir name basedir)
 		add_custom_command(
 			OUTPUT	${outfile}
-			COMMAND	xalan -in ${basedir}/${name}.xml
-				      -xsl gp/${name}.xsl -out ${outfile}
+			COMMAND	xsltproc -o ${outfile} gp/${name}.xsl
+							${basedir}/${name}.xml
 			DEPENDS ${basedir}/${name}.xml gp/${name}.xsl
 		)
 	endmacro(__GEN_GP_FILE)
@@ -99,10 +100,6 @@
 		sock_server.c
 		rand_stream.c
 	)
-endif()
-
-if (CFG_SECSTOR_TA_MGMT_PTA)
-	list (APPEND SRC install_ta.c)
 endif()
 
 if (CFG_SECURE_DATA_PATH)
@@ -129,6 +126,7 @@
 	PRIVATE .
 	PRIVATE ../supp_plugin/include
 	PRIVATE adbg/include
+	PRIVATE include/uapi
 	PRIVATE ${OPTEE_TEST_SDK}/host_include
 	PRIVATE ${CMAKE_CURRENT_BINARY_DIR}
 	${GP_INCLUDES}

=== host/xtest/Makefile ===
--- 
+++ 
@@ -139,7 +139,7 @@
 # Include configuration file generated by OP-TEE OS (CFG_* macros)
 CFLAGS += -include conf.h
 
-CFLAGS += -Wall -Wcast-align -Werror \
+CFLAGS += -Wall -Wcast-align \
 	  -Werror-implicit-function-declaration -Wextra -Wfloat-equal \
 	  -Wformat-nonliteral -Wformat-security -Wformat=2 -Winit-self \
 	  -Wmissing-declarations -Wmissing-format-attribute \
@@ -148,7 +148,12 @@
 	  -Wshadow -Wstrict-prototypes -Wswitch-default \
 	  -Wwrite-strings -Wno-unused-parameter \
 	  -Wno-declaration-after-statement \
-	  -Wno-missing-field-initializers -Wno-format-zero-length
+	  -Wno-missing-field-initializers -Wno-format-zero-length \
+	  -Wno-alloc-size
+
+ifeq ($(CFG_WERROR),y)
+CFLAGS += -Werror
+endif
 
 CFLAGS += -g3

=== ta/bti_test/Makefile ===
BINARY = 3616069b-504d-4044-9497-feb84a073a14
include ../ta_common.mk

=== ta/concurrent/Makefile ===
BINARY =  e13010e0-2ae1-11e5-896a-0002a5d5c51b
include ../ta_common.mk

=== ta/concurrent_large/Makefile ===
BINARY =  5ce0c432-0ab0-40e5-a056-782ca0e6aba2
include ../ta_common.mk

=== ta/create_fail_test/Makefile ===
BINARY = c3f6e2c0-3548-11e1-b86c-0800200c9a66
include ../ta_common.mk

=== ta/crypt/Makefile ===
BINARY =  cb3e5ba0-adf1-11e0-998b-0002a5d5c51b
include ../ta_common.mk

=== ta/crypto_perf/Makefile ===
BINARY = 02a42f43-d8b7-4a57-aa4d-87bd9b5587cb

include ../ta_common.mk

=== debian/changelog ===
optee-test (4.7.0-1) unstable; urgency=medium

  * New upstream version 4.7.0
  * Bump version of optee-*-dev to >= 4.7.0
  * Standards-Version: 4.7.2 (no changes needed)

 -- Dylan Aïssi <daissi@debian.org>  Thu, 14 Aug 2025 22:09:24 +0200

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: devel
 Priority: optional
 Maintainer: Dylan Aïssi <daissi@debian.org>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Build-Depends: debhelper-compat (= 13),
                libssl-dev,
-               optee-client-dev (>=4.5.0) [arm64],
-               optee-os-dev (>=4.5.0) [arm64],
+               optee-client-dev (>=4.7.0) [arm64],
+               optee-os-dev (>=4.7.0) [arm64],
                python3,
                python3-cryptography
 Vcs-Browser: https://salsa.debian.org/debian/optee-test

=== debian/watch ===
version=4
opts="uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/optee_test-$1\.tar\.gz/" \
  https://github.com/OP-TEE/optee_test/tags .*/v?(\d\S+)\.tar\.gz

## optee-test 4.8.0

=== debian/changelog ===
optee-test (4.8.0-1) unstable; urgency=medium

  * New upstream version 4.8.0
  * Bump version of optee-*-dev to >= 4.8.0
  * Add debian/gbp.conf

 -- Dylan Aïssi <daissi@debian.org>  Thu, 15 Jan 2026 18:17:54 +0100

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Standards-Version: 4.7.2
 Build-Depends: debhelper-compat (= 13),
                libssl-dev,
-               optee-client-dev (>=4.7.0) [arm64],
-               optee-os-dev (>=4.7.0) [arm64],
+               optee-client-dev (>=4.8.0) [arm64],
+               optee-os-dev (>=4.8.0) [arm64],
                python3,
                python3-cryptography
 Vcs-Browser: https://salsa.debian.org/debian/optee-test
